
import os
import sys
import select

try:
    import zLOG

except:
    class foo:
        pass

    def LOG( subsystem, severity, short ):
        if severity > -500:
            print subsystem, severity, short

    zLOG = foo()
    zLOG.LOG = LOG
    zLOG.BLATHER = 0
    zLOG.INFO = 1



class MyPopen3:
    def __init__(self, cmd, capturestderr=0, bufsize=-1):
        MAXFD = 256
        if type(cmd) == type(''):
            cmd = ['/bin/sh', '-c', cmd]
        p2cread, p2cwrite = os.pipe()
        c2pread, c2pwrite = os.pipe()
        if capturestderr:
            errout, errin = os.pipe()
        self.pid = os.fork()
        if self.pid == 0:
            # Child
            os.close(0)
            os.close(1)
            if os.dup(p2cread) <> 0:
                sys.stderr.write('popen2: bad read dup\n')
            if os.dup(c2pwrite) <> 1:
                sys.stderr.write('popen2: bad write dup\n')
            if capturestderr:
                os.close(2)
                if os.dup(errin) <> 2: pass
            for i in range(3, MAXFD):
                try:
                    os.close(i)
                except: pass
            try:
                os.execvp(cmd[0], cmd)
            finally:
                os._exit(1)
            # Shouldn't come here, I guess
            os._exit(1)
        os.close(p2cread)
        self.tochild = os.fdopen(p2cwrite, 'w', bufsize)
        os.close(c2pwrite)
        self.fromchild = os.fdopen(c2pread, 'r', bufsize)
        import fcntl, FCNTL
        fcntl.fcntl(self.fromchild.fileno(), FCNTL.F_SETFL, 2048) # O_NONBLOCK
        if capturestderr:
            os.close(errin)
            self.childerr = os.fdopen(errout, 'r', bufsize)
            fcntl.fcntl(self.childerr.fileno(), FCNTL.F_SETFL, 2048)
        else:
            self.childerr = None
        self.sts = -1 # Child not completed yet
        #_active.append(self)
    def wait(self):
        pid, sts = os.waitpid(self.pid, 0)
        if pid == self.pid:
            self.sts = sts
            #_active.remove(self)
        return self.sts




class ShellCommandProcessor:

    active = 0
    usepassfile = 0

    def processStreams(self, command):

        if not self.active:
            if self._v_debug:
                zLOG.LOG('ZCVSMixin', zLOG.BLATHER,
                         "Not processing streams... self.active = 0")
                
            # no commands are executed unless this is true...
            return  0, '', ''

        childInst = MyPopen3(command, 1, -1)
        child_stdout, child_stdin = childInst.fromchild, childInst.tochild
        child_stderr = childInst.childerr

        child_stdin.close()

        resultStd = ''
        resultErr = ''

        fds = [child_stdout]
        if child_stderr: fds = fds + [child_stderr]
        li = fds

        while len(fds):
            li, lo, le = select.select(fds, [], [], 20)
            if not len(li):
                break
            if child_stdout in li:
                car = ''
                try:
                    car = child_stdout.read(4096)
                except IOError, x:
                    #DBGwrite("IOError [out] %s\n>>>>>>>>>>>>> %s\n" %(x,car))
                    pass
                resultStd = resultStd + car
                if car=='':
                    #DBGwrite("------- [out] NONE -- Terminated\n")
                    fds.remove(child_stdout)
                #else:
                #    DBGwrite("------- [out] %s\n" %car)
            #else:
            #    if child_stdout in fds:
            #        DBGwrite("NOTHING [out]\n")
            if child_stderr in li:
                car = ''
                try:
                    car = child_stderr.read(2048)
                except IOError, x:
                    #DBGwrite("IOError [err] %s\n" %x)
                    pass
                resultErr = resultErr + car
                if car=='':
                    #DBGwrite("------- [err] NONE -- Terminated\n")
                    fds.remove(child_stderr)
                #else:
                #    DBGwrite("------- [err] %s\n" %car)
            #else:
            #    if child_stderr in fds:
            #        DBGwrite("NOTHING [err]\n")

        child_stdout.close()
        child_stderr.close()
        resultVal = childInst.wait()

        return resultVal, resultStd, resultErr

    def processCommands(self, command):
        return self.processStreams(command)[0]

#def DBGwrite(str):
#    dfdbg = open("/tmp/zopeCVS.log", "a+")
#    dfdbg.write(str)
#    dfdbg.close()

if __name__=='__main__':
    x = ShellCommandProcessor()
    x.active = 1

    print x.processStreams('ls -lga')
